<mat-card class="w-96">
  <mat-card-header>
    <div class="flex justify-between items-center w-full">
      <div>
        <mat-card-title>Transactions</mat-card-title>
        <mat-card-subtitle>Add your income and expenses</mat-card-subtitle>
      </div>
      <div>
        <button [matMenuTriggerFor]="cardMenu" mat-icon-button>
          <mat-icon>more_horiz</mat-icon>
        </button>
      </div>
    </div>
  </mat-card-header>
  <hr class="mt-3"/>
  <mat-card-content>
    <div class="flex flex-col gap-2 max-h-[calc(100vh-25rem)] overflow-y-auto">
      @for (transaction of transactions; track transaction; let last = $last) {
        <div class="mt-3">
          <div class="flex justify-between w-full">
            <div>
              <div class="flex items-center gap-3 mb-2">
                <span class="px-2 py-1 text-xs bg-green-300 rounded">{{ transaction.source }}</span>
              </div>
              <small>{{ transaction.description }}</small>
            </div>
            <div class="flex items-center gap-1">
                    <span class="font-bold" [class.text-green-700]="transaction.type==='credit'"
                          [class.text-red-700]="transaction.type==='debit'">
                      {{ transaction.amount | currency:'USD':'symbol':'1.2' }}
                    </span>
              <button mat-icon-button [matMenuTriggerFor]="itemMenu" [matMenuTriggerData]="{transaction}">
                <mat-icon>more_vert</mat-icon>
              </button>
            </div>
          </div>
        </div>
        @if (!last) {
          <hr/>
        }
      }
    </div>
  </mat-card-content>
  <hr class="my-3"/>
  <mat-card-actions>
    <div class="flex justify-between items-end w-full px-3">
      @if (balance$(); as balance) {
        <div class="flex flex-col gap-1">
          <span class="text-xs text-gray-500">Total balance</span>
          <span class="text-2xl" [class.text-green-700]="balance > 0" [class.text-red-700]="balance < 0">
                  {{ balance | currency:'USD':'symbol':'1.2' }}
                </span>
        </div>
      }
      <button (click)="openTransactionDialog()" class="mb-2 mr-2 w-24" color="primary" mat-raised-button>ADD</button>
    </div>
  </mat-card-actions>
</mat-card>


<mat-menu #cardMenu="matMenu">
  <button (click)="showToast$.set('Yet to come.!')" mat-menu-item>
    <div class="text-red-700">
      <mat-icon svgIcon="money-send"></mat-icon>
      <span>Debit</span>
    </div>
  </button>
  <button (click)="showToast$.set('Yet to come.!')" mat-menu-item>
    <div class="text-green-700">
      <mat-icon svgIcon="money-receive"></mat-icon>
      <span>Credit</span>
    </div>
  </button>
</mat-menu>
<mat-menu #itemMenu="matMenu">
  <ng-template let-transaction="transaction" matMenuContent>
    <button (click)="openTransactionDialog(transaction)" mat-menu-item>
      <mat-icon>edit</mat-icon>
      <span>Edit</span>
    </button>
    <button (click)="deleteTransaction$.set(transaction)" mat-menu-item>
      <mat-icon color="warn">delete</mat-icon>
      <span class="text-red-500">Delete</span>
    </button>
  </ng-template>
</mat-menu>
